package org.openjdk.gcbench.util;

import org.openjdk.gcbench.util.ratelimit.MultiTokenBucket;
import org.openjdk.gcbench.util.ratelimit.RateLimiter;
import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

@BenchmarkMode(Mode.Throughput)
@OutputTimeUnit(TimeUnit.SECONDS)
@State(Scope.Benchmark)
public class TokenBucketBench {

    private RateLimiter limiter;

    @Param({"10", "100", "1000", "10000", "100000", "1000000", "100000000"})
    int rate;

    @Setup
    public void setup() {
        limiter = new MultiTokenBucket(rate);
    }

    @Benchmark
    public void baseline() {

    }

    @Benchmark
    public void test() {
        limiter.limit();
//        return new Object();
    }

}
